<template>
  <div
    class="chat-message"
    :class="{ 'chat-message_mine': member === message.member_id }"
  >
    <div
      class="chat-message__img"
      :style="{
        background: `url(${avatarUrl}) no-repeat center center`,
      }"
    ></div>

    <div class="chat-message__info">
      <span>{{ messageTime }}</span>

      <h6>{{ formattedName }}</h6>
      <p>{{ message.message }}</p>
    </div>
  </div>
</template>

<script>
import moment from "moment";
import { mapState } from "vuex";

export default {
  name: "ChatMessage",

  props: {
    member: {
      type: Number,
    },

    message: {
      type: Object,
    },

    members: {
      type: Object,
    },
  },

  computed: {
    ...mapState({
      user: (state) => state.user.user,
      chat: (state) => state.chat.chat,
    }),

    messageType() {
      return Object.keys(
        this.members.find((member) => {
          return member.id === this.message.member_id;
        }).member
      )[0];
    },

    avatarUrl() {
      if (this.messageType === "user") {
        return this.members.find(
          (member) => member.id === this.message.member_id
        ).member.user?.avatar !== null
          ? this.members.find((member) => member.id === this.message.member_id)
              .member.user?.avatar.url.full_size
          : require("../assets/logo.svg");
      }

      return this.members.find((member) => member.id === this.message.member_id)
        .member.organization?.avatar !== null
        ? this.members.find((member) => member.id === this.message.member_id)
            .member.organization?.avatar.url.full_size
        : require("../assets/logo.svg");
    },

    formattedName() {
      if (this.member === this.message.member_id) {
        return "Вы";
      }

      if (this.messageType === "user") {
        return this.members.find(
          (member) => member.id === this.message.member_id
        ).member.user?.name;
      }

      return this.members.find((member) => member.id === this.message.member_id)
        .member.organization?.name;
    },

    messageTime() {
      return moment(this.message.created_at).format("HH:mm");
    },
  },
};
</script>

<style lang="scss" scoped>
.chat-message {
  display: flex;
  justify-content: flex-start;
  align-items: center;
  margin-bottom: 24px;

  &_mine {
    justify-content: flex-end;

    .chat-message__info {
      background-color: #5abaed;
    }

    .chat-message__img {
      display: none;
    }
  }

  &__img {
    display: flex;
    margin-right: 8px;
    height: 34px;
    width: 25px;
    border-radius: 4px;
    background-size: cover !important;
  }

  &__info {
    background-color: #179de3;
    position: relative;
    padding: 16px;
    border-radius: 4px;
    max-width: 290px;

    span {
      position: absolute;
      right: 8px;
      top: 8px;
      font-size: 10px;
      color: #fff;
      opacity: 0.5;
    }

    h6 {
      font-size: 14px;
      font-weight: 500;
      color: #fff;
    }

    p {
      font-size: 14px;
      color: #f3f7ff;
    }
  }
}
</style>
